
#import <Foundation/Foundation.h>
#import <CoreImage/CoreImage.h>
#import <UIKit/UIKit.h>
#import "QHVCEffectBase.h"

#pragma mark - FilterBase

@protocol QHVCRecordFilterEffect <NSObject>
@optional
//两种回调方式 根据具体情况 实现一种即可
- (CVPixelBufferRef)processBuffer:(CVPixelBufferRef)pixelBuffer;
- (CIImage *)processImage:(CIImage *)image;
@end

@interface QHVCRecordFilter : NSObject<QHVCRecordFilterEffect>
@end

#pragma mark - 滤镜

@interface QHVCRecordCICLUTFilter : QHVCRecordFilter
@property (nonatomic, retain) CIImage *clutImage;
@property (nonatomic, assign) CGFloat progress;
@end

#pragma mark - 动效

@interface QHVCRecordMotionFilter : QHVCRecordFilter
@property (nonatomic, strong) NSString* effctName;  //动效名
@end

#pragma mark - 贴图

@interface QHVCRecordStickerFilter : QHVCRecordFilter
@property (nonatomic, strong) UIImage* sticker;
@property (nonatomic, assign) QHVCEffectRect renderRect;  //相对输出画布的渲染区域，x、y为贴纸中心点在画布内的坐标
@property (nonatomic, assign) CGFloat renderRadian;  //初始旋转弧度值，例如，90° = π/2
@end


